Table table;
Table deweyMainNames;
float rightMargin = 300;
float leftMargin = 200;
float vertMargin = 70;
boolean deweyFilter = false;
int deweyFilterValue = 0;
int rowCount;
boolean boldness = false;
float xStretch ;
float yStretch;
float deltaX = 20;
float deltaY = 10;
float rectWidth;
float rectHeight; 


public void settings() {
    size(1400, 800); // setup the size of the window
    table = loadTable("query_main.csv");
    deweyMainNames = loadTable("dewey_main.csv");
    rowCount = table.getRowCount();    
    rectWidth = (width - (leftMargin + rightMargin))/ deltaX*0.95;  
    rectHeight = (height - 2 * vertMargin)/ deltaY*0.95;
    smooth();
}


public void rectangles() {  
  int deweyMain;
  int wordCount;
  float checkoutsPerTitleShare;
  float x ;
  float y ;
    
  xStretch = (width- (leftMargin +rightMargin))/(deltaX);
  yStretch = (height-2*vertMargin)/(deltaY);
  
  for (int row=0; row<rowCount; row ++){
    deweyMain = table.getInt(row, 0);
    wordCount = table.getInt(row, 2);
    
    checkoutsPerTitleShare = table.getFloat(row, 7)*2000;
    x = leftMargin + (wordCount-1) * xStretch;
    y = deweyMain * yStretch + vertMargin;    
    fill(checkoutsPerTitleShare);    
    rect(x, y, rectWidth, rectHeight);    
  }  
}


public void axis(){
    xAxis();
    yAxis();
}


public void yAxis(){
    fill(255);    
    float y ;
    for (int dewey=0; dewey<=9; dewey +=1){
        y = height - ((dewey) * yStretch + vertMargin) -rectHeight/2;        
        text(deweyMainNames.getString(dewey,1), vertMargin, y);
    }
}

public void xAxis(){
    fill(255);    
    text("Title length", leftMargin, 20);
    textAlign(LEFT);
    float x;
    for (int wordCount=1; wordCount<=20; wordCount ++){
        x = (wordCount-1) * xStretch + leftMargin;
        text(wordCount, x + rectWidth/2, vertMargin-10);
    }
}

public void title(){
    if (deweyFilter){
        text("Category "+deweyFilterValue+"00 ("+deweyMainNames.getString(deweyFilterValue,1)+")", width -300, 100);
    }
}


public void legend(){
  float y ;
  int colVal;
  for (int cell = 0; cell <=5; cell+=1){
    colVal = cell * 50;
    fill(colVal);
    stroke(255); 
    y = (cell * yStretch) + vertMargin +50 ;
    rect(width-rightMargin/2, y, rectWidth, rectHeight);
    fill(255);    
    textAlign(LEFT, CENTER);
    text(colVal, width-rightMargin/2-50, y+rectHeight/2);
    stroke(0);
  }
}


public void keyPressed() {
    int number;
    number = Integer.valueOf(key)-48;
    System.out.println(number);
    if (number >= 0 && number <=9){
        deweyFilter = true;
        deweyFilterValue = number;
        colorMode(RGB);
    }
    else if (key=='c') {
        deweyFilter = false;
    }
    else if (key=='b') {
        boldness = !boldness;
    }
}


public void draw(){    
    background(0);
    //lines();
    rectangles();
    axis();
    title();
    legend();
} 