SELECT 
	DeweyMain, 
    main.Dewey as Dewey, 
    title_word_count, 
    checkouts, 
    number_of_titles, 
    checkouts_per_title,
    checkouts_per_dewey,
    checkouts/checkouts_per_dewey AS checkouts_share,
    checkouts/number_of_titles/checkouts_per_dewey AS checkouts_per_dewey_share,
    number_of_titles_per_dewey,
    number_of_titles/number_of_titles_per_dewey AS number_of_titles_share
FROM
	(SELECT 
		LEFT(deweyClass, 1) AS DeweyMain,
		LEFT(deweyClass, 2) AS Dewey,
		LENGTH(title) - LENGTH(REPLACE(title, ' ','')) + 1 AS title_word_count,
		COUNT(id) AS checkouts,  
		COUNT(DISTINCT(bibNumber)) AS number_of_titles,		
		COUNT(id) / COUNT(DISTINCT(bibNumber)) AS checkouts_per_title
	FROM
		spl_2016.inraw
	WHERE 
		length(deweyClass) > 0
	AND 
		cout > '2011-01-01'
	GROUP BY 
		Dewey, title_word_count
	) AS main
LEFT JOIN 
	(SELECT 
		LEFT(deweyClass, 2) AS Dewey,	
		COUNT(DISTINCT(bibNumber)) AS number_of_titles_per_dewey,
        COUNT(id) AS checkouts_per_dewey
	FROM
		spl_2016.inraw
	WHERE 
		cout > '2011-01-01'
	GROUP BY 
		Dewey
	) AS count
ON (count.Dewey=main.Dewey)
WHERE 
	title_word_count <= 40
ORDER BY 
	main.Dewey, title_word_count;


